    #include <stdio.h>
    #include <stdlib.h>
    #include <unistd.h>
    #include <errno.h>
    #include <string.h>
    #include <sys/types.h>
    #include <sys/socket.h>
    #include <netinet/in.h>
    #include <arpa/inet.h>
    #include <time.h>
  
  
    #include <unistd.h>
    #include <signal.h>

  
    #define MYPORT 4950    // the port users will be connecting to

    #define MAXBUFLEN 1500


    volatile sig_atomic_t global_num = 0; /* gloabal variable */

    void timer_interrupt(int num)
    {
                
        global_num = ! global_num; 
        alarm (60);
        signal(SIGALRM, timer_interrupt);
        //printf("Timer interrupt %d\n",m++);
     }


  
    int main(void)
    {
    
    	int bytes_rx_total;
    	int tmp;
	int rx_fn1, rx_fn2, rx_fn3;
	float rate;
	
	FILE *f1;
                             	

       long k;
       int sockfd;
       struct sockaddr_in my_addr;    // my address information
       struct sockaddr_in their_addr; // connector's address information
       int addr_len, numbytes;
       char buf[MAXBUFLEN]; // this is used for receiving packers
       //char signalling[20]; // this is to store START message

       char * addr_string = "10.0.0.1";
       //just initialize, no special meaning 

	int test_begin, test_end, test_step;   
       
        /*-----------negotiation period ---------------------------- 
	    -----------master (AP) sending start signals to slaves. 1,2,3.....*/
       char *signalling = "100 300 10 START" ;  
        
	  test_begin = 100;
	  test_end = 300;
	  test_step = 10;   
	   
	   /* create a clent socket of datagram now, 
	   the slave nodes is already running */ 
	   
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
	 {
            perror("socket");
            exit(1);
        }

        their_addr.sin_family = AF_INET;     // host byte order
        their_addr.sin_port = htons(MYPORT); // short, network byte order
        their_addr.sin_addr.s_addr = inet_addr("10.0.0.5");
        memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct

  	 if ((numbytes=sendto(sockfd, signalling, strlen(signalling), 0,
	 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}
		
	 their_addr.sin_addr.s_addr = inet_addr("10.0.0.4");
        memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct

  	 if ((numbytes=sendto(sockfd, signalling, strlen(signalling), 0,
	 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1)
		{
			perror("sendto");
			exit(1);
		}

	 close (sockfd);
	  
	 /* ------------negotiotion finished ------------------------*/
	 
	 /* begin a 1-second timer  test preparation will be done in this
	 second*/
	        /* waiting for timeout */
	 
	 
	alarm (61);  /* one minute is basic test period plus one sec preparation timeslot */
	signal(SIGALRM, timer_interrupt);

       
	/*------Sever Started
	wait for slaves begin test-peration
	test prepare will be cost 1 sec.
	then begin receiving packets and make statistics */

        if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         // host byte order
        my_addr.sin_port = htons(MYPORT);     // short, network byte order
        my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
        memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

        if (bind(sockfd, (struct sockaddr *)&my_addr,sizeof(struct sockaddr)) == -1)
	 {
            perror("bind");
            exit(1);
        }

	

	printf ( " A Datagram Server is runnning on this AP!\n Waiting for FN ....\n ");
	
	
	if ( (f1=fopen ("flow.dat", "w")) == NULL ) printf ("file open error\n");
	
	
	k = test_begin;
//	printf ( "%c\n", strchr ("10.0.0.2", 7) );
	
	while ( k<= test_end )
	{
	    bytes_rx_total = 0;
		rx_fn1=0;
		rx_fn2=0;
		rx_fn3=0;

	    
	    tmp = global_num;
	
		while ( global_num == tmp )
		{
	
 	      	 	addr_len = sizeof(struct sockaddr);
 	       	if ((numbytes=recvfrom(sockfd,buf, MAXBUFLEN-1, 0,
                           (struct sockaddr *)&their_addr, (socklen_t*)&addr_len)) == -1)
		 	{
 	           		perror("recvfrom");
		 	           exit(1);
 	      		 }

 	       	/* statisttical numbers for packets per sec */
	
			addr_string =  inet_ntoa(their_addr.sin_addr) ;
		
			bytes_rx_total += numbytes;
	 
	 
			 if ( strchr ( addr_string , '5') != NULL)
		 		rx_fn3+=numbytes;
			 else if  (strchr ( addr_string, '4') != NULL)
			 	rx_fn2+=numbytes;
			 else if ( strchr (addr_string, '2') != NULL )
		 		rx_fn1+=numbytes;
	
		  }	    

       /*
	printf ("total bytes received : %d bytes \n", bytes_rx_total );
	printf ("total bytes received from FN1  : %d bytes \n",rx_fn1 );
	printf ("total bytes received from FN2 : %d bytes \n",rx_fn2 );
	printf ("total bytes received from FN3 : %d bytes \n",rx_fn3 );
	*/
	fprintf ( f1, "%d %d %d %d %d\n" , k, bytes_rx_total, rx_fn1, rx_fn2, rx_fn3);
	
	k+=test_step;
	
}
	fclose (f1);
       close(sockfd);
	      
       return 0;
}
